/* plannercore.vapi generated by valac 0.52.4, do not modify. */

namespace Services {
	namespace Calendar {
		[CCode (cheader_filename = "plannercore.h")]
		public class CalendarModel : GLib.Object {
			public CalendarModel ();
			public async void get_all_sources (Gtk.ListBox listbox);
			public Util.DateRange data_range { get; private set; }
			public GLib.DateTime month_start { get; set; }
			public int num_weeks { get; private set; }
			public E.SourceRegistry registry { get; private set; }
			public GLib.HashTable<E.Source,Gee.TreeMultiMap<string,ECal.Component>> source_events { get; private set; }
			public GLib.DateWeekday week_starts_on { get; set; }
			public signal void events_added (E.Source source, Gee.Collection<ECal.Component> events);
			public signal void events_removed (E.Source source, Gee.Collection<ECal.Component> events);
			public signal void events_updated (E.Source source, Gee.Collection<ECal.Component> events);
		}
	}
	namespace Chrono {
		[CCode (cheader_filename = "plannercore.h")]
		public class Chrono : GLib.Object {
			public Chrono ();
			public Objects.Duedate? get_next_recurring (Objects.Item item, int value, string lang = "en");
			public Objects.Duedate? parse (string expression, string lang);
			public Services.Chrono.en en { get; set; }
			public Services.Chrono.extras extras { get; set; }
			public static Services.Chrono.Chrono instance { get; }
		}
		[CCode (cheader_filename = "plannercore.h")]
		public class en : GLib.Object {
			public en ();
			public Objects.Duedate? get_next_recurring (Objects.Item item, int value);
			public Objects.Duedate? parse (string expression);
			public static Services.Chrono.en instance { get; }
		}
		[CCode (cheader_filename = "plannercore.h")]
		public class extras : GLib.Object {
			public extras ();
			public Objects.Duedate? parse (string expression);
			public static Services.Chrono.extras instance { get; }
		}
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class ActionManager : GLib.Object {
		public static Gee.MultiMap<string,string> action_accelerators;
		public static Gee.MultiMap<string,string> typing_accelerators;
		public const string ACTION_ADD_TASK;
		public const string ACTION_ADD_TASK_PASTE;
		public const string ACTION_ADD_TASK_TOP;
		public const string ACTION_ESC;
		public const string ACTION_NEW_PROJECT;
		public const string ACTION_NEW_SECTION;
		public const string ACTION_OPEN_NEW_PROJECT_WINDOW;
		public const string ACTION_OPEN_SEARCH;
		public const string ACTION_PREFERENCES;
		public const string ACTION_PREFIX;
		public const string ACTION_QUIT;
		public const string ACTION_SHORTCUTS;
		public const string ACTION_SORT_DATE;
		public const string ACTION_SORT_NAME;
		public const string ACTION_SORT_PRIORITY;
		public const string ACTION_SYNC_MANUALLY;
		public const string ACTION_VIEW_HOME;
		public const string ACTION_VIEW_INBOX;
		public const string ACTION_VIEW_TODAY;
		public const string ACTION_VIEW_UPCOMING;
		public const string HIDE_ALL;
		public ActionManager (Planner planner_app, MainWindow window);
		public GLib.SimpleActionGroup actions { get; construct; }
		public weak Planner app { get; construct; }
		public weak MainWindow window { get; construct; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class CustomShortcutSettings : GLib.Object {
		public struct CustomShortcut {
			public string shortcut;
			public string command;
			public string relocatable_schema;
		}
		public static bool available;
		public CustomShortcutSettings ();
		public static string? create_shortcut ();
		public static bool edit_command (string relocatable_schema, string command);
		public static bool edit_shortcut (string relocatable_schema, string shortcut);
		public static void init ();
		public static GLib.List<Services.CustomShortcutSettings.CustomShortcut?> list_custom_shortcuts ();
	}
	[CCode (cheader_filename = "plannercore.h")]
	[DBus (name = "com.github.alainm23.planner")]
	public class DBusServer : GLib.Object {
		public DBusServer ();
		public void add_item (int64 id) throws GLib.IOError, GLib.DBusError;
		public static unowned Services.DBusServer get_default ();
		public bool settings_get_boolean (string key) throws GLib.IOError, GLib.DBusError;
		public signal void item_added (int64 id);
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Database : GLib.Object {
		public Gee.ArrayList<Objects.Item?> items_to_delete;
		public Database ();
		public void add_int64_column (string table, string col, int64 default_value);
		public void add_int_column (string table, string col, int default_value);
		public bool add_item_label (int64 item_id, Objects.Label label);
		public bool add_item_to_delete (Objects.Item item);
		public void add_text_column (string table, string col, string default_value);
		public void clear_cur_temp_ids ();
		public bool clear_item_label (int64 id);
		public void clear_queue ();
		public bool column_exists (string table, string col);
		public Objects.Project create_inbox_project ();
		public bool curTempIds_exists (int64 id);
		public void delete_item (Objects.Item item);
		public bool delete_item_label (int64 id, int64 item_id, Objects.Label label);
		public bool delete_label (int64 id);
		public void delete_label_todoist ();
		public void delete_project (int64 id);
		public bool delete_reminder (int64 id);
		public void delete_section (Objects.Section section);
		public bool exists_item_label (int64 item_id, int64 label_id);
		public Gee.ArrayList<Objects.Item?> get_all_cheks_by_item (int64 id);
		public Gee.ArrayList<Objects.Item?> get_all_completed_items ();
		public Gee.ArrayList<Objects.Item?> get_all_completed_items_by_inbox (int64 id);
		public Gee.ArrayList<Objects.Item?> get_all_completed_items_by_parent (int64 id);
		public Gee.ArrayList<Objects.Item?> get_all_completed_items_by_project (int64 id);
		public Gee.ArrayList<Objects.Item?> get_all_completed_items_by_project_no_section_no_parent (int64 id);
		public Gee.ArrayList<Objects.Item?> get_all_completed_items_by_section_no_parent (Objects.Section section);
		public int get_all_count_items_by_parent (int64 id);
		public int get_all_count_items_by_project (int64 id);
		public Gee.ArrayList<Objects.Item?> get_all_items ();
		public Gee.ArrayList<Objects.Item?> get_all_items_by_inbox (int64 id, int is_todoist);
		public Gee.ArrayList<Objects.Item?> get_all_items_by_project (int64 id);
		public Gee.ArrayList<Objects.Item?> get_all_items_by_project_no_section (Objects.Project project);
		public Gee.ArrayList<Objects.Item?> get_all_items_by_project_no_section_no_parent (int64 id);
		public Gee.ArrayList<Objects.Item?> get_all_items_by_section (int64 id);
		public Gee.ArrayList<Objects.Item?> get_all_items_by_section_no_parent (Objects.Section section);
		public Gee.ArrayList<Objects.Item?> get_all_items_uncompleted ();
		public Gee.ArrayList<Objects.Label?> get_all_labels ();
		public Gee.ArrayList<Objects.Item?> get_all_overdue_items ();
		public Gee.ArrayList<Objects.Project?> get_all_projects ();
		public Gee.ArrayList<Objects.Project?> get_all_projects_by_parent (int64 id);
		public Gee.ArrayList<Objects.Project?> get_all_projects_by_search (string search_text);
		public Gee.ArrayList<Objects.Project?> get_all_projects_by_todoist ();
		public Gee.ArrayList<Objects.Project?> get_all_projects_no_parent ();
		public Gee.ArrayList<Objects.Queue?> get_all_queue ();
		public Gee.ArrayList<Objects.Section?> get_all_sections ();
		public Gee.ArrayList<Objects.Section?> get_all_sections_by_project (int64 id);
		public Gee.ArrayList<Objects.Section?> get_all_sections_by_search (string search_text);
		public Gee.ArrayList<Objects.Item?> get_all_today_completed_items ();
		public Gee.ArrayList<Objects.Item?> get_all_today_items ();
		public int get_count_checked_items_by_parent (int64 id);
		public int get_count_checked_items_by_project (int64 id);
		public int get_count_items_by_project (int64 id);
		public int get_count_sections_by_project (int64 id);
		public string get_database_path ();
		public Objects.Reminder? get_first_reminders_by_item (int64 id);
		public Objects.Item? get_item_by_id (int64 id);
		public int64 get_item_label (int64 item_id, int64 label_id);
		public Gee.ArrayList<Objects.Item?> get_items_by_date (GLib.DateTime date);
		public Gee.ArrayList<Objects.Item?> get_items_by_label (int64 id);
		public Gee.ArrayList<Objects.Item?> get_items_by_priority (int priority);
		public Gee.ArrayList<Objects.Item?> get_items_by_search (string search_text);
		public Objects.Label get_label_by_id (int64 id);
		public Gee.ArrayList<Objects.Label?> get_labels_by_item (int64 id);
		public Gee.ArrayList<Objects.Label?> get_labels_by_project (int64 id);
		public Gee.ArrayList<Objects.Label?> get_labels_by_search (string search_text);
		public int get_past_count ();
		public Objects.Project? get_project_by_id (int64 id);
		public int get_project_count (int64 id);
		public int get_project_count_by_area (int64 id);
		public Objects.Queue get_queue_by_object_id (int64 id);
		public GLib.Array<string> get_quick_find_recents ();
		public Objects.Reminder get_reminder_by_id (int64 id);
		public Gee.ArrayList<Objects.Reminder?> get_reminders ();
		public Gee.ArrayList<Objects.Reminder?> get_reminders_by_item (int64 id);
		public Objects.Section get_section_by_id (int64 id);
		public string get_temp_id (int64 id);
		public int get_today_count ();
		public int get_today_project_count (int64 id);
		public bool insert_CurTempIds (int64 id, string temp_id, string object);
		public bool insert_collaborator (Objects.Collaborator collaborator);
		public bool insert_item (Objects.Item item, int index = -1);
		public bool insert_label (Objects.Label label);
		public bool insert_project (Objects.Project project);
		public bool insert_queue (Objects.Queue queue);
		public void insert_quickfind_recents (string type, string object);
		public bool insert_reminder (Objects.Reminder reminder);
		public bool insert_section (Objects.Section section, int index = -1);
		public bool is_database_empty ();
		public bool item_exists (int64 id);
		public bool label_exists (int64 id);
		public bool label_name_exists (string name);
		public bool move_item (Objects.Item item, int64 project_id, int section_id = 0, int index = -1);
		public void move_item_parent (Objects.Item item, int64 parent_id);
		public void move_item_section (Objects.Item item, int64 section_id);
		public void move_item_section_parent (Objects.Item item, int64 section_id, int64 parent_id);
		public bool move_project (Objects.Project project, int64 parent_id);
		public bool move_section (Objects.Section section, int64 project_id);
		public void open_database ();
		public void patch_database ();
		public bool project_exists (int64 id);
		public bool projects_area_exists (int64 id);
		public void remove_CurTempIds (int64 id);
		public void remove_item_to_delete ();
		public void remove_queue (string uuid);
		public void reset_all ();
		public void reset_database_path_to_default ();
		public bool section_exists (int64 id);
		public void set_database_path (string path);
		public bool set_due_item (Objects.Item item, bool new_date, int index = -1);
		public void update_check_order (Objects.Item item, int64 parent_id, int item_order);
		public bool update_item (Objects.Item item);
		public void update_item_completed (Objects.Item item, bool undo = false);
		public void update_item_id (int64 current_id, int64 new_id);
		public void update_item_order (Objects.Item item, int64 section_id, int item_order);
		public void update_item_project_id (Objects.Item item, int64 project_id);
		public void update_item_recurring_due_date (Objects.Item item, int value = 1);
		public bool update_label (Objects.Label label);
		public void update_label_item_order (int64 id, int item_order);
		public void update_project (Objects.Project project);
		public void update_project_id (int64 current_id, int64 new_id);
		public void update_project_item_order (int64 project_id, int64 parent_id, int item_order);
		public void update_queue (Objects.Queue queue);
		public void update_section (Objects.Section section);
		public void update_section_id (int64 current_id, int64 new_id);
		public void update_section_item_order (int64 section_id, int item_order);
		public void update_sort_order_project (int64 project_id, int orden);
		public void update_today_day_order (Objects.Item item, int day_order);
		public signal void add_due_item (Objects.Item item, int index);
		public signal void check_project_count (int64 project_id);
		public signal void delete_undo_item (Objects.Item item);
		public signal void item_added (Objects.Item item, int index);
		public signal void item_completed (Objects.Item item);
		public signal void item_deleted (Objects.Item item);
		public signal void item_id_updated (int64 current_id, int64 new_id);
		public signal void item_label_added (int64 id, int64 item_id, Objects.Label label);
		public signal void item_label_deleted (int64 id, int64 item_id, Objects.Label label);
		public signal void item_moved (Objects.Item item, int64 project_id, int64 old_project_id, int index);
		public signal void item_parent_moved (Objects.Item item, int64 parent_id, int64 old_parent_id);
		public signal void item_section_moved (Objects.Item item, int64 section_id, int64 old_section_id);
		public signal void item_section_parent_moved (Objects.Item item, int64 section_id, int64 old_section_id, int64 parent_id, int64 old_parent_id);
		public signal void item_uncompleted (Objects.Item item);
		public signal void item_updated (Objects.Item item);
		public signal void label_added (Objects.Label label);
		public signal void label_deleted (int64 id);
		public signal void label_updated (Objects.Label label);
		public signal void on_drag_item_deleted (Widgets.ItemRow row, int64 section_id);
		public signal void opened ();
		public signal void project_added (Objects.Project project);
		public signal void project_deleted (int64 id);
		public signal void project_id_updated (int64 current_id, int64 new_id);
		public signal void project_moved (Objects.Project project, int64 parent_id, int64 old_parent_id);
		public signal void project_show_completed (Objects.Project project);
		public signal void project_updated (Objects.Project project);
		public signal void reminder_added (Objects.Reminder reminder);
		public signal void reminder_deleted (int64 id);
		public signal void remove_due_item (Objects.Item item);
		public signal void reset ();
		public signal void section_added (Objects.Section section, int index);
		public signal void section_deleted (Objects.Section section);
		public signal void section_id_updated (int64 current_id, int64 new_id);
		public signal void section_moved (Objects.Section section, int64 project_id, int64 old_project_id);
		public signal void section_updated (Objects.Section section);
		public signal void show_toast_delete (int count);
		public signal void show_undo_item (Objects.Item item, string type = "");
		public signal void subtract_task_counter (int64 id);
		public signal void update_all_bage ();
		public signal void update_due_item (Objects.Item item, int index);
		public signal void update_project_count (int64 id, int items_0, int items_1);
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class EventBus : GLib.Object {
		public EventBus ();
		public void test (string caller_id);
		public bool ctrl_pressed { get; set; }
		public signal void area_unselect_all ();
		public signal void connect_typing_accel ();
		public signal void ctrl_press ();
		public signal void ctrl_release ();
		public signal void day_changed ();
		public signal void disconnect_typing_accel ();
		public signal void drag_magic_button_activated (bool active);
		public signal void edit_project (int64 project_id);
		public signal void edit_tasklist (string uid);
		public signal void filter_label_activated (int64 project_id, Gee.Collection<Objects.Label> values);
		public signal void hide_items_project (int64 project_id);
		public signal void hide_new_window_project (int64 project_id);
		public signal void magic_button_activated (int64 project_id, int64 section_id, int is_todoist, int index, string view = "project", string due_date = "");
		public signal void magic_button_visible (bool active);
		public signal void pane_selected (PaneType pane_type, string id);
		public signal void project_selected (int64 project_id);
		public signal void select_item (Widgets.ItemRow row);
		public signal void show_new_window_project (int64 project_id);
		public signal void show_undo_task (string uid, string type = "");
		public signal void sort_items_project (int64 project_id, int orden);
		public signal void sync ();
		public signal void unselect_all ();
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class ExportImport : GLib.Object {
		public ExportImport ();
		public void export_to_json (string path);
		public void import_backup ();
		public void save_file_as ();
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class LabelsController : GLib.Object {
		public LabelsController ();
		public void add_label (Objects.Label label);
		public void update_label (Objects.Label label);
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Notifications : GLib.Object {
		public Notifications ();
		public void init_server ();
		public void queue_reminder_notification (int64 reminder_id, string uid);
		public void send_system_notification (string title, string body, string icon_name, GLib.NotificationPriority priority);
		public signal void send_notification (string message, NotificationStyle style = NotificationStyle.NORMAL);
		public signal void send_undo_notification (string message, string query);
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class PluginsManager : GLib.Object {
		public PluginsManager ();
		public Gtk.Widget get_view ();
		public Plugins.Interface plugin_iface { get; private set; }
		public signal void extension_added (Peas.PluginInfo info);
		public signal void extension_removed (Peas.PluginInfo info);
		public signal void hook_widgets (MainWindow window, Widgets.Pane pane);
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Todoist : GLib.Object {
		public Gee.ArrayList<Objects.Item?> items_to_complete;
		public Gee.ArrayList<Objects.Item?> items_to_delete;
		public Todoist ();
		public async void add_all_labels ();
		public bool add_delete_item (Objects.Item item);
		public async void add_item (Objects.Item item, GLib.Cancellable cancellable, int index, int64 temp_id_mapping, Gee.Collection<Widgets.LabelItem> labels = null);
		public async void add_label (Objects.Label label, int64 temp_id_mapping, GLib.Cancellable cancellable = null);
		public async void add_project (Objects.Project project, GLib.Cancellable cancellable, int64 temp_id_mapping);
		public async void add_section (Objects.Section section, GLib.Cancellable cancellable, int64 temp_id_mapping, int index = -1);
		public void convert_to_todoist (Objects.Project project);
		public void delete_label (Objects.Label label);
		public void delete_project (Objects.Project project);
		public void delete_section (Objects.Section section);
		public async void first_sync (string token, string view);
		public string get_add_item_json (Objects.Item item, Gee.Collection<Widgets.LabelItem> labels = null, string temp_id, string uuid);
		public string get_add_label_json (Objects.Label label, string temp_id, string uuid);
		public string get_add_project_json (Objects.Project project, string temp_id, string uuid);
		public string get_add_section_json (Objects.Section section, string temp_id, string uuid);
		public string get_convert_project_json (Objects.Project project);
		public string get_delete_json (int64 id, string type, string uuid);
		public int64 get_int_member_by_object (string object, string member);
		public string get_move_json (int64 id, string type, int64 project_id, string uuid);
		public string get_move_parent_json (Objects.Item item, int64 parent_id, string uuid);
		public string get_move_section_json (Objects.Item item, int64 section_id, string uuid);
		public Json.Object get_object_by_string (string object);
		public string get_queue_json (Gee.ArrayList<Objects.Queue?> queue);
		public string get_string_member_by_object (string object, string member);
		public void get_todoist_token (string url, string view);
		public GLib.Type get_type_by_member (string object, string member);
		public void item_complete (Objects.Item item);
		public void item_uncomplete (Objects.Item item);
		public void log_out ();
		public void move_item (Objects.Item item, int64 project_id);
		public void move_item_to_parent (Objects.Item item, int64 parent_id);
		public void move_item_to_section (Objects.Item item, int64 section_id);
		public async void move_project (Objects.Project project, int64 parent_id);
		public void move_section (Objects.Section section, int64 id);
		public void queue ();
		public void run_server ();
		public void share_project (int64 project_id, string email);
		public async void sync ();
		public void update_item (Objects.Item item);
		public async void update_label (Objects.Label label);
		public void update_project (Objects.Project project);
		public void update_section (Objects.Section section);
		public signal void avatar_downloaded (string id);
		public signal void convert_error (int64 id);
		public signal void convert_finished (int64 id);
		public signal void first_sync_finished ();
		public signal void first_sync_started ();
		public signal void item_added_completed (int64 id);
		public signal void item_added_error (int64 id, int error_code, string error_message);
		public signal void item_added_started (int64 id);
		public signal void item_completed_completed (Objects.Item item);
		public signal void item_completed_error (Objects.Item item, int error_code, string error_message);
		public signal void item_completed_started (Objects.Item item);
		public signal void item_moved_completed (int64 id);
		public signal void item_moved_error (int64 id, int error_code, string error_message);
		public signal void item_moved_started (int64 id);
		public signal void item_uncompleted_completed (Objects.Item item);
		public signal void item_uncompleted_error (Objects.Item item, int error_code, string error_message);
		public signal void item_uncompleted_started (Objects.Item item);
		public signal void item_updated_completed (int64 id);
		public signal void item_updated_error (int64 id, int error_code, string error_message);
		public signal void item_updated_started (int64 id);
		public signal void label_added_completed (int64 id, Objects.Label label);
		public signal void label_added_error (int64 id, int error_code, string error_message);
		public signal void label_added_started (int64 id);
		public signal void project_added_completed (int64 temp_id_mapping, int64 project_id);
		public signal void project_added_error (int64 temp_id_mapping, int error_code, string error_message);
		public signal void project_added_started (int64 temp_id_mapping);
		public signal void project_deleted_completed (int64 id);
		public signal void project_deleted_error (int64 id, int error_code, string error_message);
		public signal void project_deleted_started (int64 id);
		public signal void project_updated_completed (int64 id);
		public signal void project_updated_error (int64 id, int error_code, string error_message);
		public signal void project_updated_started (int64 id);
		public signal void section_added_completed (int64 id);
		public signal void section_added_error (int64 id, int error_code, string error_message);
		public signal void section_added_started (int64 id);
		public signal void section_deleted_completed (int64 id);
		public signal void section_deleted_error (int64 id, int error_code, string error_message);
		public signal void section_deleted_started (int64 id);
		public signal void section_moved_completed (int64 id);
		public signal void section_moved_error (int64 id, int error_code, string error_message);
		public signal void section_moved_started (int64 id);
		public signal void section_updated_completed (int64 id);
		public signal void section_updated_error (int64 id, int error_code, string error_message);
		public signal void section_updated_started (int64 id);
		public signal void sync_finished ();
		public signal void sync_started ();
	}
}
namespace Util {
	[CCode (cheader_filename = "plannercore.h")]
	public class DateIterator : GLib.Object, Gee.Traversable<GLib.DateTime>, Gee.Iterator<GLib.DateTime> {
		public DateIterator (Util.DateRange range);
		public GLib.DateTime current { get; set construct; }
		public Util.DateRange range { get; construct; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class DateRange : GLib.Object, Gee.Traversable<GLib.DateTime>, Gee.Iterable<GLib.DateTime> {
		public DateRange (GLib.DateTime first, GLib.DateTime last);
		public bool equals (Util.DateRange other);
		public Gee.List<GLib.DateTime> to_list ();
		public GLib.DateTime first_dt { get; construct; }
		public GLib.DateTime last_dt { get; construct; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public static bool calcomp_is_on_day (ECal.Component comp, GLib.DateTime day);
	[CCode (cheader_filename = "plannercore.h")]
	public static int calcomponent_compare_func (ECal.Component? a, ECal.Component? b);
	[CCode (cheader_filename = "plannercore.h")]
	public static bool calcomponent_equal_func (ECal.Component a, ECal.Component b);
	[CCode (cheader_filename = "plannercore.h")]
	public static string get_source_location (E.Source source);
	[CCode (cheader_filename = "plannercore.h")]
	public static GLib.DateTime get_start_of_month (owned GLib.DateTime? date = null);
	[CCode (cheader_filename = "plannercore.h")]
	public static GLib.DateTime ical_to_date_time (ICal.Time date);
	[CCode (cheader_filename = "plannercore.h")]
	public static bool is_the_all_day (GLib.DateTime dtstart, GLib.DateTime dtend);
	[CCode (cheader_filename = "plannercore.h")]
	public static async void reset_timer ();
	[CCode (cheader_filename = "plannercore.h")]
	public static void set_event_calendar_color (E.SourceCalendar cal, Gtk.Widget widget);
	[CCode (cheader_filename = "plannercore.h")]
	public static bool source_equal_func (E.Source a, E.Source b);
	[CCode (cheader_filename = "plannercore.h")]
	public static uint source_hash_func (E.Source key);
	[CCode (cheader_filename = "plannercore.h")]
	public static GLib.DateTime strip_time (GLib.DateTime datetime);
	[CCode (cheader_filename = "plannercore.h")]
	public static GLib.TimeZone timezone_from_ical (ICal.Time date);
}
namespace Plugins {
	[CCode (cheader_filename = "plannercore.h")]
	public class Interface : GLib.Object {
		public Services.PluginsManager manager;
		public Interface (Services.PluginsManager manager);
		public signal void hook_widgets (MainWindow window, Widgets.Pane pane);
	}
}
namespace Widgets {
	namespace Calendar {
		[CCode (cheader_filename = "plannercore.h")]
		public class Calendar : Gtk.Box {
			public Calendar (bool block_past_days = false);
			public void next_month ();
			public void previous_month ();
			public bool block_past_days { get; construct; }
			public GLib.DateTime date { get; }
			public signal void selection_changed (GLib.DateTime date);
		}
		[CCode (cheader_filename = "plannercore.h")]
		public class CalendarDay : Gtk.EventBox {
			public CalendarDay ();
			public int day { get; set; }
			public signal void day_selected (int day);
		}
		[CCode (cheader_filename = "plannercore.h")]
		public class CalendarHeader : Gtk.Box {
			public CalendarHeader ();
			public GLib.DateTime date { set; }
			public signal void center_clicked ();
			public signal void left_clicked ();
			public signal void right_clicked ();
		}
		[CCode (cheader_filename = "plannercore.h")]
		public class CalendarView : Gtk.Box {
			public CalendarView ();
			public void fill_grid_days (int start_day, int max_day, int current_day, bool is_current_month, bool block_past_days = false, GLib.DateTime month = new GLib.DateTime.now_local ());
			public signal void day_selected (int day);
		}
		[CCode (cheader_filename = "plannercore.h")]
		public class CalendarWeek : Gtk.Grid {
			public CalendarWeek ();
			public void update ();
		}
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class ActionRow : Gtk.ListBoxRow {
		public Gtk.Label title_name;
		public ActionRow (PaneView view);
		public void clear_indicator (Gdk.DragContext context);
		public string get_view_string ();
		public void on_drag_item_leave (Gdk.DragContext context, uint time);
		public bool on_drag_item_motion (Gdk.DragContext context, int x, int y, uint time);
		public void on_drag_leave (Gdk.DragContext context, uint time);
		public bool on_drag_motion (Gdk.DragContext context, int x, int y, uint time);
		public Gtk.Image icon { get; set; }
		public bool reveal_child { get; set; }
		public bool reveal_drag_motion { get; set; }
		public PaneView view { get; construct; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class BoardColumn : Gtk.FlowBoxChild {
		public Gee.HashMap<string,Widgets.ItemRow> items_completed_added;
		public Gee.ArrayList<Widgets.ItemRow?> items_list;
		public Gee.HashMap<string,Widgets.ItemRow> items_uncompleted_added;
		public Gtk.Revealer main_revealer;
		public BoardColumn (Objects.Section section, Objects.Project project);
		public void add_all_items ();
		public void add_new_item (int index = -1);
		public void clear_indicator (Gdk.DragContext context);
		public BoardColumn.for_project (Objects.Project project);
		public void hide_items ();
		public void on_drag_leave (Gdk.DragContext context, uint time);
		public void on_drag_magicbutton_leave (Gdk.DragContext context, uint time);
		public bool on_drag_magicbutton_motion (Gdk.DragContext context, int x, int y, uint time);
		public bool on_drag_motion (Gdk.DragContext context, int x, int y, uint time);
		public void save (bool todoist = true);
		public Objects.Project project { get; construct; }
		public Objects.Section section { get; construct; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class BoardView : Gtk.EventBox {
		public BoardView ();
		public void add_boards ();
		public void add_new_item (int index = -1);
		public void remove_boards ();
		public Objects.Project project { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class CheckRow : Gtk.ListBoxRow {
		public CheckRow (Objects.Item item);
		public void clear_indicator (Gdk.DragContext context);
		public void edit ();
		public void on_drag_leave (Gdk.DragContext context, uint time);
		public bool on_drag_motion (Gdk.DragContext context, int x, int y, uint time);
		public Objects.Item item { get; construct; }
		public signal void enter_activate (Widgets.CheckRow row);
		public signal void hide_item ();
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class ColorPopover : Gtk.Popover {
		public ColorPopover ();
		public int selected { get; set; }
		public signal void color_changed (int color);
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class DateTimeButton : Gtk.Revealer {
		public DateTimeButton ();
		public signal void clicked ();
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class DueButton : Gtk.ToggleButton {
		public DueButton (Objects.Item item);
		public string get_string_selected ();
		public DueButton.new_item ();
		public void set_due (string date);
		public void update_date_text (Objects.Item item);
		public Objects.Item item { get; construct; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Entry : Gtk.Entry {
		public Entry ();
		public bool update_on_leave ();
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class EventRow : Gtk.ListBoxRow {
		public EventRow (GLib.DateTime date, ICal.Component component, E.Source source);
		public weak E.SourceCalendar cal { get; construct; }
		public weak ICal.Component component { get; construct; }
		public GLib.DateTime date { get; construct; }
		public GLib.DateTime? end_time { get; private set; }
		public bool is_allday { get; private set; }
		public E.Source source { get; set; }
		public GLib.DateTime start_time { get; private set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Feature : Gtk.EventBox {
		public Feature (Gtk.Image? image, string option_text, string description_text);
		public string description { get; set; }
		public Gtk.Image? icon { get; set; }
		public string title { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class ImageMenuItem : Gtk.MenuItem {
		public Gtk.Image item_image;
		public ImageMenuItem (string text, string icon, string tooltip = "");
		public int color { set; }
		public bool due_label { set; }
		public string icon { set; }
		public string text { set; }
		public string tooltip { set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class ItemCompletedRow : Gtk.ListBoxRow {
		public ItemCompletedRow (Objects.Item item, string view = "project");
		public void hide_destroy ();
		public Objects.Item item { get; construct; }
		public string view { get; construct; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class ItemRow : Gtk.ListBoxRow {
		public Gee.HashMap<string,Widgets.ItemRow> items_completed_added;
		public Gee.HashMap<string,Widgets.ItemRow> items_uncompleted_added;
		public Gee.HashMap<string,bool> labels_hashmap;
		public Gtk.Revealer main_revealer;
		public ItemRow (Objects.Item item, string view = "project");
		public void check_reminder_preview_label (Objects.Reminder? reminder);
		public void clear_indicator (Gdk.DragContext context);
		public void content_entry_focus ();
		public void hide_destroy ();
		public void hide_item ();
		public void on_drag_leave (Gdk.DragContext context, uint time);
		public bool on_drag_motion (Gdk.DragContext context, int x, int y, uint time);
		public void show_item ();
		public Objects.Item item { get; construct; }
		public bool item_selected { set; }
		public bool reveal_child { get; set; }
		public bool reveal_drag_motion { get; set; }
		public string view { get; set; }
		public signal void update_headers ();
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class LabelButton : Gtk.ToggleButton {
		public LabelButton (int64 item_id);
		public LabelButton.new_item ();
		public bool update_on_leave ();
		public int64 item_id { get; construct; }
		public Gee.HashMap<string,Widgets.LabelItem> labels_map { get; set; }
		public signal void clear ();
		public signal void closed ();
		public signal void label_selected (Objects.Label label, bool active);
		public signal void show_popover ();
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class LabelFilter : Gtk.ToggleButton {
		public Gee.HashMap<string,Objects.Label> labels_loaded;
		public Gee.HashMap<string,Objects.Label> labels_selected;
		public LabelFilter ();
		public Objects.Project project { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class LabelFilterRow : Gtk.ListBoxRow {
		public LabelFilterRow (Objects.Label label);
		public void update_checked (bool active);
		public Objects.Label label { get; construct; }
		public signal void toggled (Objects.Label label);
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class LabelItem : Gtk.EventBox {
		public LabelItem (int64 id, int64 item_id, Objects.Label label);
		public void hide_destroy ();
		public int64 id { get; construct; }
		public int64 item_id { get; construct; }
		public Objects.Label label { get; construct; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class LabelPopoverRow : Gtk.ListBoxRow {
		public LabelPopoverRow (int64 item_id, Objects.Label label, Gee.HashMap<string,Widgets.LabelItem> labels_map);
		public bool toggled ();
		public int64 item_id { get; construct; }
		public Objects.Label label { get; construct; }
		public Gee.HashMap<string,Widgets.LabelItem> labels_map { get; construct; }
		public signal void label_checked (Objects.Label label, bool active);
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class LabelPreview : Gtk.EventBox {
		public LabelPreview (int64 id, int64 item_id, Objects.Label label);
		public int64 id { get; construct; }
		public int64 item_id { get; construct; }
		public Objects.Label label { get; construct; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class LabelRow : Gtk.ListBoxRow {
		public Gtk.Revealer main_revealer;
		public Gtk.Adjustment vadjustment;
		public LabelRow (Objects.Label label);
		public void clear_indicator (Gdk.DragContext context);
		public void edit ();
		public void on_drag_leave (Gdk.DragContext context, uint time);
		public bool on_drag_motion (Gdk.DragContext context, int x, int y, uint time);
		public Objects.Label label { get; construct; }
		public Gtk.ScrolledWindow scrolled { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class ListView : Gtk.EventBox {
		public ListView ();
		public void add_new_item (int index = -1);
		public void add_new_section_row (int index);
		public void add_sections ();
		public void remove_sections ();
		public Objects.Project project { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class MagicButton : Gtk.Revealer {
		public Gtk.Button magic_button;
		public MagicButton ();
		public void on_drag_end (Gdk.DragContext context);
		public signal void clicked ();
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class ModelButton : Gtk.Button {
		public Gtk.Image item_image;
		public ModelButton (string text, string icon, string tooltip = "", bool arrow = false);
		public bool arrow { get; construct; }
		public int color { set; }
		public bool due_label { set; }
		public string icon { set; }
		public string text { set; }
		public string tooltip { set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class MultiSelectToolbar : Gtk.Revealer {
		public Gee.HashMap<string,Widgets.ItemRow> items_selected;
		public MultiSelectToolbar ();
		public void set_priority (int priority);
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class New : Gtk.Revealer {
		public Widgets.Entry name_entry;
		public Gtk.Stack stack;
		public New ();
		public int? get_color_selected ();
		public bool reveal { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class NewCheck : Gtk.EventBox {
		public NewCheck (int64 item_id, int64 project_id, int64 section_id, int is_todoist = 0);
		public int is_todoist { get; construct; }
		public int64 item_id { get; construct; }
		public int64 project_id { get; construct; }
		public bool reveal_child { get; set; }
		public int64 section_id { get; construct; }
		public int64 temp_id_mapping { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class NewItem : Gtk.ListBoxRow {
		public Gee.HashMap<string,Widgets.LabelItem> labels_map;
		public NewItem (int64 project_id, int64 section_id, int is_todoist, string due_date = "", int index = -1, Gtk.ListBox? listbox = null, int priority = 1, int64 parent_id = 0);
		public void entry_grab_focus ();
		public NewItem.for_source (E.Source source, Gtk.ListBox? listbox = null);
		public void hide_destroy ();
		public void parse_item_tags (string text);
		public string due_date { get; set; }
		public int index { get; set; }
		public int is_todoist { get; set; }
		public Gtk.ListBox? listbox { get; set; }
		public bool loading { set; }
		public int64 parent_id { get; set; }
		public int priority { get; set; }
		public int64 project_id { get; set; }
		public int64 section_id { get; set; }
		public E.Source source { get; set; }
		public int64 temp_id_mapping { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class NewLabel : Gtk.EventBox {
		public NewLabel ();
		public void on_drag_leave (Gdk.DragContext context, uint time);
		public bool on_drag_motion (Gdk.DragContext context, int x, int y, uint time);
		public signal void insert_row (Widgets.LabelRow row, int position);
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class NewSection : Gtk.ListBoxRow {
		public NewSection (int64 project_id, int is_todoist, int index);
		public void hide_destroy ();
		public int index { get; set; }
		public int is_todoist { get; set; }
		public int64 project_id { get; set; }
		public int64 temp_id_mapping { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Pane : Gtk.EventBox {
		public Gtk.Box add_project_buttonbox;
		public Gtk.ScrolledWindow buttonbox_scrolled;
		public Gtk.ListBox listbox;
		public Gtk.Grid listbox_grid;
		public Widgets.New new_project;
		public Gtk.ListBox project_listbox;
		public Gee.ArrayList<Widgets.ProjectRow?> projects_list;
		public Widgets.ToolsMenu tools_menu;
		public Pane ();
		public void add_all_projects ();
		public void add_label (Objects.Label label);
		public void add_local_source_button ();
		public void select_item (PaneView view);
		public void set_visible_new_widget (bool value);
		public void set_visible_tool_widget (bool value);
		public bool visible_new_widget ();
		public bool visible_tool_widget ();
		public bool sensitive_ui { set; }
		public signal void label_selected (Objects.Label label);
		public signal void project_selected (int64 id);
		public signal void show_quick_find ();
		public signal void tasklist_selected (E.Source source);
		public signal void view_selected (int64 id);
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Placeholder : Gtk.Revealer {
		public Placeholder (string title, string subtitle, string icon_name);
		public string icon_name { get; construct; }
		public string subtitle { get; construct; }
		public string title { get; construct; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class PopoverButton : Gtk.Button {
		public PopoverButton (string text, string? icon, string[]? accels = null);
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class PriorityButton : Gtk.ToggleButton {
		public PriorityButton (Objects.Item item);
		public void set_priority (int priority);
		public void update_icon (Objects.Item item);
		public Objects.Item item { get; construct; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class ProjectProgress : Gtk.Bin {
		public bool enable_subprojects;
		public bool has_subprojects;
		public double line_width;
		public double subproject_line_width;
		public int subproject_offset;
		public ProjectProgress (int min_d = 18);
		public override bool draw (Cairo.Context cr);
		public override void get_preferred_height (out int min_h, out int natural_h);
		public override void get_preferred_width (out int min_w, out int natural_w);
		public override Gtk.SizeRequestMode get_request_mode ();
		public override void size_allocate (Gtk.Allocation allocation);
		public int min_d { get; construct; }
		[Description (blurb = "The percentage value [0.0 ... 1.0]", nick = "Percentage/Value")]
		public double percentage { get; set; }
		[Description (blurb = "Progress line color (Check GdkRGBA parse method)", nick = "Progress fill color")]
		public string progress_fill_color { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class ProjectRow : Gtk.ListBoxRow {
		public Gtk.Revealer main_revealer;
		public Gee.ArrayList<Widgets.ProjectRow?> projects_list;
		public Gtk.Adjustment vadjustment;
		public ProjectRow (Objects.Project project);
		public void clear_indicator (Gdk.DragContext context);
		public void on_drag_item_leave (Gdk.DragContext context, uint time);
		public bool on_drag_item_motion (Gdk.DragContext context, int x, int y, uint time);
		public void on_drag_leave (Gdk.DragContext context, uint time);
		public bool on_drag_motion (Gdk.DragContext context, int x, int y, uint time);
		public Objects.Project project { get; construct; }
		public bool reveal_drag_motion { get; set; }
		public Gtk.ScrolledWindow scrolled { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class ReminderButton : Gtk.ToggleButton {
		public ReminderButton (Objects.Item item);
		public void check_reminder_label (Objects.Reminder? first_reminder);
		public Objects.Item item { get; construct; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class ReminderRow : Gtk.ListBoxRow {
		public ReminderRow (Objects.Reminder reminder);
		public Objects.Reminder reminder { get; construct; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class ScheduleButton : Gtk.ToggleButton {
		public ScheduleButton (Objects.Item item);
		public void clear ();
		public string get_due_date ();
		public bool has_datetime ();
		public ScheduleButton.new_item ();
		public void save_item ();
		public void set_datetime (GLib.DateTime datetime);
		public void set_new_item_due_date (string due_date);
		public void update_duedate (Objects.Item item);
		public Services.Chrono.Chrono chrono { get; set construct; }
		public Objects.Duedate duedate { get; set; }
		public Objects.Item item { get; construct; }
		public signal void popover_opened (bool active);
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class ScheduleRow : Gtk.Revealer {
		public Gtk.Image item_image;
		public Gtk.Label item_label;
		public Gtk.Label preview_label;
		public Gtk.Revealer selected_revealer;
		public ScheduleRow (string text, string icon, bool with_preview = false);
		public string date_label { set; }
		public string icon { set; }
		public bool selected { set; }
		public string text { set; }
		public bool with_preview { get; construct; }
		public signal void clicked ();
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class SectionRow : Gtk.ListBoxRow {
		public Gee.HashMap<string,Widgets.ItemRow> items_completed_added;
		public Gee.ArrayList<Widgets.ItemRow?> items_list;
		public Gee.HashMap<string,Widgets.ItemRow> items_uncompleted_added;
		public SectionRow (Objects.Section section, Objects.Project project);
		public void add_all_items ();
		public void add_new_item (int index = -1);
		public void clear_indicator (Gdk.DragContext context);
		public SectionRow.for_project (Objects.Project project);
		public void hide_items ();
		public void on_drag_leave (Gdk.DragContext context, uint time);
		public void on_drag_magicbutton_leave (Gdk.DragContext context, uint time);
		public bool on_drag_magicbutton_motion (Gdk.DragContext context, int x, int y, uint time);
		public bool on_drag_motion (Gdk.DragContext context, int x, int y, uint time);
		public void save (bool todoist = true);
		public Objects.Project project { get; construct; }
		public Objects.Section section { get; construct; }
		public signal void add_new_section_row (int index);
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class ShortcutLabel : Gtk.Grid {
		public ShortcutLabel (string[] accels);
		public void update_accels (string[] accels);
		public string[] accels { get; construct; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class SortButton : Gtk.ToggleButton {
		public SortButton ();
		public Objects.Project project { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class SourceButton : Gtk.Button {
		public SourceButton (string primary_text, string source, string icon_name, string key = "", string tipo);
		public string icon_name { get; construct; }
		public string key { get; construct; }
		public bool loading { get; set; }
		public string primary_text { get; construct; }
		public string source { get; construct; }
		public int64 temp_id_mapping { get; set; }
		public string tipo { get; construct; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class SourceItem : Gtk.ListBoxRow {
		public SourceItem (E.Source source);
		public string label { get; private set; }
		public string location { get; private set; }
		public E.Source source { get; private set; }
		public bool source_enabled { get; }
		public signal void edit_request (E.Source source);
		public signal void remove_request (E.Source source);
		public signal void visible_changed ();
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class SyncButton : Gtk.Button {
		public SyncButton ();
		public bool is_loading { set; }
		public bool network_available { set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class TextView : Gtk.TextView {
		public TextView ();
		public bool update_on_leave ();
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class TimeAlternativeButton : Gtk.Button {
		public TimeAlternativeButton (string text, string key);
		public string key { get; construct; }
		public string text { get; construct; }
		public GLib.DateTime time { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Toast : Gtk.Revealer {
		public Toast (string title, string query = "", NotificationStyle notification_type);
		public void run_query ();
		public void send_notification ();
		public NotificationStyle notification_type { get; construct; }
		public string query { get; construct; }
		public string title { get; construct; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class ToggleButton : Gtk.ToggleButton {
		public Gtk.Image item_image;
		public Gtk.Label item_label;
		public ToggleButton (string title, string icon);
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class ToolMenuItem : Gtk.Button {
		public ToolMenuItem (string text, string[] accels);
		public string[] accels { get; construct; }
		public string text { get; construct; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class ToolsMenu : Gtk.ToggleButton {
		public ToolsMenu ();
		public void check_network_available ();
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class UpcomingRow : Gtk.ListBoxRow {
		public Gee.ArrayList<Widgets.ItemRow?> items_list;
		public Gee.HashMap<string,Widgets.ItemRow> items_loaded;
		public UpcomingRow (GLib.DateTime date);
		public void hide_items ();
		public void on_drag_magicbutton_leave (Gdk.DragContext context, uint time);
		public bool on_drag_magicbutton_motion (Gdk.DragContext context, int x, int y, uint time);
		public GLib.DateTime date { get; construct; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class WhatsNew : Hdy.Window {
		protected Gtk.Grid options;
		public WhatsNew (string app_icon, string app_description);
		public void append (string icon_name, string option_text, string description_text);
		public void append_notes (string title, GLib.List<string> list, int margin_start);
		public void append_with_image (Gtk.Image? image, string option_text, string description_text);
		public Gtk.Label get_note (string title);
		public string app_description { set; }
		public string icon { set; }
	}
}
namespace Views {
	[CCode (cheader_filename = "plannercore.h")]
	public class AllTasks : Gtk.EventBox {
		public Gee.HashMap<string,Widgets.ItemRow> items_loaded;
		public AllTasks ();
		public void hide_items ();
		public int priority { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Completed : Gtk.EventBox {
		public Gee.HashMap<string,Widgets.ItemRow> items_loaded;
		public Completed ();
		public void add_all_items ();
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Filter : Gtk.EventBox {
		public Gee.HashMap<string,Widgets.ItemRow> items_loaded;
		public Filter ();
		public void add_new_item (int index = -1);
		public void clear ();
		public void hide_items ();
		public string filter { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Inbox : Gtk.EventBox {
		public Inbox (Objects.Project project);
		public void add_new_item (int index);
		public void open_new_section ();
		public Objects.Project project { get; construct; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Label : Gtk.EventBox {
		public Gee.HashMap<string,Widgets.ItemRow> items_loaded;
		public Label ();
		public void hide_items ();
		public Objects.Label label { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Project : Gtk.EventBox {
		public Project ();
		public void build_progress_popover ();
		public void edit ();
		public void open_new_section ();
		public void open_progress_popover ();
		public Objects.Project project { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Today : Gtk.EventBox {
		public Gee.HashMap<string,Widgets.ItemRow> items_completed_added;
		public Today ();
		public void add_items ();
		public void add_new_item (int index = -1);
		public void hide_items ();
		public void hide_last_item ();
		public void share_markdown ();
		public void share_today_mail ();
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Upcoming : Gtk.EventBox {
		public Gee.ArrayList<Widgets.ItemRow?> items_opened;
		public Upcoming ();
		public void hide_items ();
		public GLib.DateTime date { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Welcome : Gtk.EventBox {
		public Welcome ();
		public signal void activated (int index);
	}
}
namespace Dialogs {
	namespace Preferences {
		[CCode (cheader_filename = "plannercore.h")]
		public class DatabaseSettings : Gtk.EventBox {
			public DatabaseSettings ();
		}
		[CCode (cheader_filename = "plannercore.h")]
		public class Item : Gtk.EventBox {
			public string _icon;
			public string _title;
			public Gtk.Image icon_image;
			public Item (string icon, string title, bool last = false);
			public string icon { get; set; }
			public bool last { get; construct; }
			public string title { get; set; }
			public signal void activated ();
		}
		[CCode (cheader_filename = "plannercore.h")]
		public class ItemButton : Gtk.EventBox {
			public Gtk.Label title_label;
			public ItemButton (string title, string button_text, bool visible_separator = true);
			public signal void activated ();
		}
		[CCode (cheader_filename = "plannercore.h")]
		public class ItemSelect : Gtk.EventBox {
			public ItemSelect (string title, int active, GLib.List<string> items, bool visible_separator = true);
			public void set_combobox_sensitive (bool sensitive);
			public signal void activated (int active);
		}
		[CCode (cheader_filename = "plannercore.h")]
		public class ItemSwitch : Gtk.EventBox {
			public ItemSwitch (string title, bool active = false, bool visible_separator = true);
			public signal void activated (bool active);
		}
		[CCode (cheader_filename = "plannercore.h")]
		public class ItemTimePicker : Gtk.EventBox {
			public ItemTimePicker (string title, string key, bool visible_separator = true);
		}
		[CCode (cheader_filename = "plannercore.h")]
		public class Preferences : Hdy.Window {
			public Preferences (string view = "home");
			public string view { get; construct; }
		}
		[CCode (cheader_filename = "plannercore.h")]
		public class TopBox : Hdy.HeaderBar {
			public TopBox (string icon, string title);
			public signal void back_activated ();
			public signal void done_activated ();
		}
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Project : Hdy.Window {
		public Project (Objects.Project project, bool only_window = false);
		public void build_progress_popover ();
		public override bool configure_event (Gdk.EventConfigure event);
		public void open_progress_popover ();
		public bool only_window { get; construct; }
		public Objects.Project project { get; construct; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class ProjectSettings : Hdy.Window {
		public ProjectSettings (Objects.Project project);
		public int? get_color_selected ();
		public Objects.Project project { get; construct; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class QuickFind : Hdy.Window {
		public QuickFind ();
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class ShortcutsDialog : Hdy.Window {
		public ShortcutsDialog ();
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class TodoistOAuth : Hdy.Window {
		public TodoistOAuth (string view = "welcome");
		public string view { get; construct; }
	}
}
namespace Synapse {
	[CCode (cheader_filename = "plannercore.h")]
	public abstract class Match : GLib.Object {
		public enum Score {
			INCREMENT_MINOR,
			INCREMENT_SMALL,
			INCREMENT_MEDIUM,
			INCREMENT_LARGE,
			URI_PENALTY,
			POOR,
			BELOW_AVERAGE,
			AVERAGE,
			ABOVE_AVERAGE,
			GOOD,
			VERY_GOOD,
			EXCELLENT,
			HIGHEST
		}
		protected Match ();
		public virtual void execute (Synapse.Match? match);
		public virtual void execute_with_target (Synapse.Match? source, Synapse.Match? target = null);
		public virtual bool needs_target ();
		public virtual Synapse.QueryFlags target_flags ();
		public string description { get; set; }
		public bool has_thumbnail { get; set construct; }
		public string? icon_name { get; set construct; }
		public Synapse.MatchType match_type { get; set construct; }
		public string? thumbnail_path { get; set construct; }
		public string title { get; set construct; }
		public signal void executed ();
	}
	[CCode (cheader_filename = "plannercore.h")]
	public struct Query {
		public string query_string;
		public string query_string_folded;
		public GLib.Cancellable cancellable;
		public Synapse.QueryFlags query_type;
		public uint max_results;
		public uint query_id;
		public Query (uint query_id, string query, Synapse.QueryFlags flags = QueryFlags.LOCAL_CONTENT, uint num_results = 96);
		public static Gee.List<Gee.Map.Entry<GLib.Regex,int>> get_matchers_for_query (string query, Synapse.MatcherFlags match_flags = 0, GLib.RegexCompileFlags flags = GLib.RegexCompileFlags.OPTIMIZE);
		public bool is_cancelled ();
	}
	[CCode (cheader_filename = "plannercore.h")]
	public enum MatchType {
		UNKNOWN,
		TEXT,
		APPLICATION,
		GENERIC_URI,
		ACTION,
		SEARCH,
		CONTACT
	}
	[CCode (cheader_filename = "plannercore.h")]
	[Flags]
	public enum MatcherFlags {
		NO_REVERSED,
		NO_SUBSTRING,
		NO_PARTIAL,
		NO_FUZZY
	}
	[CCode (cheader_filename = "plannercore.h")]
	[Flags]
	public enum QueryFlags {
		INCLUDE_REMOTE,
		UNCATEGORIZED,
		APPLICATIONS,
		ACTIONS,
		AUDIO,
		VIDEO,
		DOCUMENTS,
		IMAGES,
		FILES,
		PLACES,
		INTERNET,
		TEXT,
		CONTACTS,
		ALL,
		LOCAL_CONTENT
	}
}
namespace Objects {
	[CCode (cheader_filename = "plannercore.h")]
	public class Collaborator : GLib.Object {
		public Collaborator ();
		public void save ();
		public string email { get; set; }
		public string full_name { get; set; }
		public int64 id { get; set; }
		public string image_id { get; set; }
		public string timezone { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Duedate : GLib.Object {
		public Duedate ();
		public string get_default_date_format ();
		public string get_due_date ();
		public string get_icon ();
		public string get_relative_date_format ();
		public bool has_time ();
		public bool is_valid ();
		public void no_time ();
		public void set_time (GLib.DateTime time);
		public void update_date (GLib.DateTime new_date);
		public GLib.DateTime datetime { get; set; }
		public bool is_recurring { get; set; }
		public string lang { get; set; }
		public string text { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Item : GLib.Object {
		public Item ();
		public void convert_to_project ();
		public void get_duplicate ();
		public void save ();
		public void save_local ();
		public void share_markdown ();
		public void share_text ();
		public string to_json ();
		public int64 assigned_by_uid { get; set; }
		public int checked { get; set; }
		public int collapsed { get; set; }
		public string content { get; set; }
		public string date_added { get; set; }
		public string date_completed { get; set; }
		public string date_updated { get; set; }
		public int day_order { get; set; }
		public string due_date { get; set; }
		public int due_is_recurring { get; set; }
		public string due_lang { get; set; }
		public string due_string { get; set; }
		public string due_timezone { get; set; }
		public int64 id { get; set; }
		public int is_deleted { get; set; }
		public int is_todoist { get; set; }
		public int item_order { get; set; }
		public string note { get; set; }
		public int64 parent_id { get; set; }
		public int priority { get; set; }
		public int64 project_id { get; set; }
		public int64 responsible_uid { get; set; }
		public int64 section_id { get; set; }
		public int64 sync_id { get; set; }
		public int64 user_id { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Label : GLib.Object {
		public Label ();
		public void save ();
		public string to_json ();
		public int color { get; set; }
		public int64 id { get; set; }
		public int is_deleted { get; set; }
		public int is_favorite { get; set; }
		public int is_todoist { get; set; }
		public int64 item_label_id { get; set; }
		public int item_order { get; set; }
		public string name { get; set; }
		public int64 project_id { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Project : GLib.Object {
		public Project ();
		public void save (bool todoist = true);
		public void share_mail ();
		public void share_markdown ();
		public string to_json ();
		public int64 area_id { get; set; }
		public int collapsed { get; set; }
		public int color { get; set; }
		public string due_date { get; set; }
		public int64 id { get; set; }
		public int inbox_project { get; set; }
		public int is_archived { get; set; }
		public int is_deleted { get; set; }
		public int is_favorite { get; set; }
		public int is_kanban { get; set; }
		public int64 is_sync { get; set; }
		public int is_todoist { get; set; }
		public int item_order { get; set; }
		public string name { get; set; }
		public string note { get; set; }
		public int64 parent_id { get; set; }
		public int shared { get; set; }
		public int show_completed { get; set; }
		public int sort_order { get; set; }
		public int team_inbox { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Queue : GLib.Object {
		public Queue ();
		public string args { get; set; }
		public string date_added { get; set; }
		public int64 object_id { get; set; }
		public string query { get; set; }
		public string temp_id { get; set; }
		public string uuid { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Reminder : GLib.Object {
		public string _project_name;
		public Reminder ();
		public string content { get; set; }
		public GLib.DateTime datetime { get; }
		public string due_date { get; set; }
		public int due_is_recurring { get; set; }
		public string due_lang { get; set; }
		public string due_string { get; set; }
		public string due_timezone { get; set; }
		public int64 id { get; set; }
		public int is_deleted { get; set; }
		public int is_todoist { get; set; }
		public int64 item_id { get; set; }
		public int mm_offset { get; set; }
		public int64 notify_uid { get; set; }
		public int64 project_id { get; set; }
		public string project_name { get; }
		public string service { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Section : GLib.Object {
		public Section ();
		public void save (bool todoist = true);
		public void share_markdown ();
		public string to_json ();
		public int collapsed { get; set; }
		public string date_added { get; set; }
		public string date_archived { get; set; }
		public int64 id { get; set; }
		public int is_archived { get; set; }
		public int is_deleted { get; set; }
		public int is_todoist { get; set; }
		public int item_order { get; set; }
		public string name { get; set; }
		public string note { get; set; }
		public int64 project_id { get; set; }
		public int64 sync_id { get; set; }
	}
	[CCode (cheader_filename = "plannercore.h")]
	public class Shortcuts : GLib.Object {
		public Shortcuts (string name, string[] accels);
		public string[] accels { get; set; }
		public string name { get; set; }
	}
}
namespace Constants {
	[CCode (cheader_filename = "plannercore.h")]
	public const string DATADIR;
	[CCode (cheader_filename = "plannercore.h")]
	public const string GETTEXT_PACKAGE;
	[CCode (cheader_filename = "plannercore.h")]
	public const string INSTALL_PREFIX;
	[CCode (cheader_filename = "plannercore.h")]
	public const string PLUGINDIR;
	[CCode (cheader_filename = "plannercore.h")]
	public const string PROJECT_NAME;
	[CCode (cheader_filename = "plannercore.h")]
	public const string VERSION;
}
[CCode (cheader_filename = "plannercore.h")]
public enum QuickFindResultType {
	NONE,
	ITEM,
	PROJECT,
	SECTION,
	VIEW,
	LABEL,
	RECENT,
	FILTERS
}
[CCode (cheader_filename = "plannercore.h")]
public enum NotificationStyle {
	NORMAL,
	ERROR
}
[CCode (cheader_filename = "plannercore.h")]
public enum PaneView {
	INBOX,
	TODAY,
	UPCOMING,
	COMPLETED,
	ALLTASKS
}
[CCode (cheader_filename = "plannercore.h")]
public enum PaneType {
	ACTION,
	PROJECT,
	LABEL,
	TASKLIST
}
[CCode (cheader_filename = "plannercore.h")]
[DBus (name = "com.github.alainm23.planner")]
public errordomain DBusServerError {
	SOME_ERROR
}
[CCode (cheader_filename = "plannercore.h")]
public class Planner : Gtk.Application {
	public static Planner _instance;
	public static Services.Calendar.CalendarModel calendar_model;
	public static Services.Database database;
	public static Services.EventBus event_bus;
	public MainWindow? main_window;
	public static Services.Notifications notifications;
	public static Services.PluginsManager plugins;
	public static GLib.Settings settings;
	public static Services.Todoist todoist;
	public static Utils utils;
	public const GLib.OptionEntry[] PLANNER_OPTIONS;
	public Planner ();
	protected override void activate ();
	public static int main (string[] args);
	public static Planner instance { get; }
	public signal void go_view (string type, int64 id, int64 id_2);
}
[CCode (cheader_filename = "plannercore.h")]
public class MainWindow : Hdy.ApplicationWindow {
	public Services.ActionManager action_manager;
	public Gtk.Stack main_stack;
	public Gtk.Stack project_stack;
	public MainWindow (Planner application);
	public void add_task_action (int index);
	public void add_task_clipboard_action (string text);
	public override bool configure_event (Gdk.EventConfigure event);
	public void go_filter (string filter);
	public void go_home ();
	public void go_item (int64 item_id);
	public void go_label (int64 label_id);
	public void go_project (int64 project_id);
	public void go_view (PaneView view);
	public void hide_all ();
	public void hide_item ();
	public void init_progress_controller ();
	public void new_project ();
	public void new_section_action ();
	public void open_new_project_window ();
	public void show_quick_find ();
	public void sort (int sort);
	public weak Planner app { get; construct; }
}
[CCode (cheader_filename = "plannercore.h")]
public class Utils : GLib.Object {
	public string APP_FOLDER;
	public string AVATARS_FOLDER;
	public GLib.Settings h24_settings;
	public Utils ();
	public Gee.HashMap<string,int> FULL_MONTH_NAME_DICTIONARY ();
	public Gee.HashMap<string,int> MONTH_DICTIONARY ();
	public void apply_styles (string id, string color);
	public void apply_theme_changed ();
	public string build_undo_object (string type, string object_type, string object_id, string undo_type, string undo_value);
	public Gdk.RGBA calculate_shade (string hex, double percentage);
	public string calculate_tint (string hex);
	public bool check_regex (GLib.Regex regex, string expression);
	public Gee.HashMap<int,string> color ();
	public Gee.HashMap<int,string> color_name ();
	public void create_default_labels ();
	public void create_dir_with_parents (string dir);
	public Objects.Project create_tutorial_project ();
	public ICal.Time date_time_to_ical (GLib.DateTime date, GLib.DateTime? time_local, string? timezone = null);
	public void download_profile_image (string? id, string avatar);
	public int find_most_likely_ad_year (int year_number);
	public int64 generate_id (int len = 10);
	public string generate_string ();
	public string generate_temp_id ();
	public string get_color (int key);
	public Gee.ArrayList<int> get_color_list ();
	public string get_color_name (int key);
	public string get_contrast (string hex);
	public GLib.DateTime get_date_with_time_from_string (string due_date);
	public string get_datetime (GLib.DateTime date);
	public int get_days_of_month (int index, int year_nav);
	public string get_default_date_format_from_date (GLib.DateTime date);
	public string get_default_date_format_from_string (string due_date);
	public string get_default_time_format ();
	public string get_dialog_text (string text);
	public string get_encode_text (string text);
	public GLib.DateTime get_format_date (GLib.DateTime date);
	public GLib.DateTime get_format_date_from_string (string due_date);
	public int get_int_by_paneview (PaneView value);
	public string get_markdown_to_markup (string text, string identifier, string htmltag);
	public string get_markup_format (string _text, int is_todoist = 0);
	public int get_month_number_by_query (string name);
	public GLib.DateTime? get_next_recurring_due_date (Objects.Item item, int value = 1);
	public string get_os_info (string field);
	public PaneView get_paneview_by_enum (int value);
	public PaneView get_paneview_by_string (string value);
	public Gee.ArrayList<string> get_patrons ();
	public string get_random_avatar ();
	public int get_recurring_iter (Objects.Item item);
	public string get_relative_date_from_date (GLib.DateTime date);
	public string get_relative_date_from_string (string due);
	public string get_relative_datetime_from_string (string date);
	public string get_relative_time_from_string (string due);
	public Gee.ArrayList<Objects.Shortcuts?> get_shortcuts ();
	public GLib.DateTime get_time_by_hour_minute (int hour, int minute);
	public GLib.DateTime? get_todoist_datetime (string date);
	public string get_todoist_datetime_format (string date);
	public string get_todoist_error (int code);
	public bool has_time (GLib.DateTime datetime);
	public bool has_time_from_string (string date);
	public void init_labels_color ();
	public bool is_clock_format_12h ();
	public bool is_current_month (GLib.DateTime date);
	public bool is_disconnected ();
	public bool is_flatpak ();
	public bool is_overdue (GLib.DateTime date);
	public bool is_today (GLib.DateTime date);
	public bool is_todoist_error (int status_code);
	public bool is_tomorrow (GLib.DateTime date);
	public bool is_upcoming (GLib.DateTime date);
	public string line_break_to_space (string str);
	public void open_whats_new_dialog ();
	public void set_autostart (bool active);
	public void set_quick_add_shortcut (string QUICK_ADD_SHORTCUT, bool enabled);
	public void update_font_scale ();
	public signal void add_item_show_queue (Widgets.ItemRow row);
	public signal void add_item_show_queue_view (Widgets.ItemRow row, string view);
	public signal void clock_format_changed ();
	public signal void drag_item_activated (bool active);
	public signal void highlight_item (int64 item_id);
	public signal void insert_project_to_area (int64 area_id);
	public signal void magic_button_clicked (string view);
	public signal void pane_action_selected ();
	public signal void remove_item_show_queue (Widgets.ItemRow row);
	public signal void remove_item_show_queue_view (Widgets.ItemRow row, string view);
}
[CCode (cheader_filename = "plannercore.h")]
public class RegexMarkdown {
	public RegexMarkdown (string match, string text, string extra = "");
	public string extra { get; set; }
	public string match { get; set; }
	public string text { get; set; }
}
[CCode (cheader_filename = "plannercore.h")]
public class SearchProject : Gtk.ListBoxRow {
	public SearchProject (Objects.Project project);
	public Objects.Project project { get; set construct; }
}
[CCode (cheader_filename = "plannercore.h")]
public class SearchItem : Gtk.ListBoxRow {
	public Gtk.Label header_label;
	public Gtk.Revealer shortcut_revealer;
	public SearchItem (QuickFindResultType result_type, string object, string search_term);
	public string object { get; construct; }
	public QuickFindResultType result_type { get; set construct; }
	public string search_term { get; construct; }
}
[CCode (cheader_filename = "plannercore.h")]
public class PreferenceItemRadio : Gtk.RadioButton {
	public PreferenceItemRadio ();
}
[CCode (cheader_filename = "plannercore.h")]
public class PreferencePerson : Gtk.ListBoxRow {
	public PreferencePerson (string fullname);
	public string fullname { get; construct; }
}
